unit Scrmbl;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, Buttons;

type
  TLevel = 1..2;
  TScrmbl = class(TCustomPanel)
  private
    { Private declarations }
    FLevel: TLevel;
    FDragAble: Boolean;
    FCongrats: Boolean;
    FStart: Boolean;
    But: Array[1..5,1..5] of TBitBtn;
    procedure SetLevel(Value: TLevel);
    procedure Resize; Override;
    procedure WMNCHitTest(var Mes: TWMNCHitTest); Message WM_NCHitTest;
    procedure ButtonMouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
    procedure ButtonClick(Sender: TObject);
    procedure ButtonsInit;
    procedure ButtonsPos;
    procedure ButtonsColors;
    procedure Congratulations;
  protected
    { Protected declarations }
    property Congrats: Boolean read FCongrats write FCongrats default False;
  public
    { Public declarations }
    constructor Create(AOwner:TComponent); Override;
    destructor Destroy; Override;
    property Level: TLevel read FLevel Write SetLevel default 1;
  published
    { Published declarations }
  end;

implementation
var
z,m,n,ni,nj,i,j,num: ShortInt;
he,wi: Integer;
str: String[2];

constructor TScrmbl.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
    Color:=clBlack;
    FCongrats:=False;
    ButtonsInit;
    ButtonsPos;
    ButtonsColors;
end;

destructor TScrmbl.Destroy;
begin
try
  for i:=1 to 5 do
  for j:=1 to 5 do
  But[i,j].Hide;
  for i:=1 to 5 do
  for j:=1 to 5 do
  But[i,j].Free;
Finally
  Inherited Destroy;
end;
end;

procedure Colors(i,j: byte; But: TBitBtn);
begin
     if (But.Caption=IntToStr(j+Pred(i)*5)) then
      But.Font.Color:=clGreen else
      But.Font.Color:=clRed;
end;

Procedure TScrmbl.ButtonsInit;
begin
for i:=1 to 5 do
for j:=1 to 5 do
begin
But[i,j]:=TBitBtn.Create(Self);
  With But[i,j] do
  begin
  Hide;
  Parent:=Self;
  Tag:=Pred(i)*5+j;
  Caption:=InttoStr(Tag);
  Name:='bitbtn'+Caption;
  OnClick:=ButtonClick;
  OnMouseDown:=ButtonMouseDown;
  he:=Round(Parent.Height div 5);
  wi:=Round(Parent.Width div 5);
  SetBounds(wi*Pred(j),he*Pred(i),wi,he);
  end;
end;
end;

procedure TScrmbl.ButtonsPos;
var
l,max: Integer;
temp: Shortint;
begin
   if FLevel=1 then
   begin z:=4; num:=19; end
   else begin z:=5; num:=25; end;
Randomize;
max:=5000+Random(1000);
i:=z; j:=z;
for l:=1 to max do
begin
m:=Random(2);
n:=Pred(m*2);
   ni:=i+n; nj:=j+n;
   if (nj in [1..z])  then
                      begin
                      But[i,j].Tag:=But[i,nj].Tag;
                      But[i,nj].Tag:=num;
                      temp:=j; j:=nj; nj:=temp;
                      end
   else
   if (ni in [1..z])  then
                      begin
                      But[i,j].Tag:=But[ni,j].Tag;
                      But[ni,j].Tag:=num;
                      temp:=i; i:=ni; ni:=temp;
                      end;
end;
for i:=1 to z do
for j:=1 to z do
But[i,j].Caption:=IntToStr(But[i,j].Tag);
end;

procedure TScrmbl.ButtonsColors;
begin
 if Flevel=1 then
 for i:=1 to 5 do
 begin
 But[i,5].enabled:=False;
 But[5,i].enabled:=False;
 end;
if FLevel=1 then num:=19 else num:=25;
for i:=1 to 5 do
for j:=1 to 5 do
begin
Colors(i,j,But[i,j]);
if (But[i,j].Tag<>num) then But[i,j].Show;
end;
end;

procedure TScrmbl.SetLevel(Value: TLevel);
begin
if FLevel = Value then exit;
FLevel:=Value;
FCongrats:=False;
for i:=1 to 5 do
for j:=1 to 5 do
But[i,j].Hide;
for i:=1 to 5 do
for j:=1 to 5 do
But[i,j].Free;
 ButtonsInit;
 ButtonsPos;
 ButtonsColors;
 SetBounds(0,0,Width,Height);
end;

procedure TScrmbl.ButtonMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
inherited MouseDown(Button,Shift,X,Y);
if (Button=mbRight) then
   begin
   if Level=1 then Level:=2 else Level:=1;
   if not(ssCtrl in Shift) then
   if Level=1 then Level:=2 else Level:=1;
   end;
end;


Procedure TScrmbl.ButtonClick(Sender: TObject);
var
k,l: ShortInt;
a,b: Integer;
begin
if FCongrats then
   begin
   (Sender as TBitBtn).enabled:=false;
   exit;
   end;
if FLevel=1 then begin z:=4; Str:='19'; end
          else begin z:=5; Str:='25'; end;
for i:=1 to z do
for j:=1 to z do
if (But[i,j].Caption='19') then
begin a:=i*But[i,j].Height; b:=j*But[i,j].Width; end;
for i:=1 to z do
for j:=1 to z do
begin
if (But[i,j].focused) then
for m:=0 to 1 do
  begin
  n:=Pred(m*2);
  nj:=j+n; ni:=i+n;
  if(nj in [1..z])then
  if (But[i,nj].Caption=Str)
  then begin
       But[i,nj].Caption:=But[i,j].Caption;
       But[i,j].Caption:=Str;
       Colors(i,nj,But[i,nj]);
       But[i,nj].Show;
       But[i,j].Hide;
       end;
  if (ni in [1..z]) then
  if (But[ni,j].Caption=Str)
  then begin
       But[ni,j].Caption:=But[i,j].Caption;
       But[i,j].Caption:=Str;
       Colors(ni,j,But[ni,j]);
       But[ni,j].Show;
       But[i,j].Hide;
       end;
  end;
end;
k:=0;
for i:=1 to z do
for j:=1 to z do
if But[i,j].Font.Color=clGreen then Inc(k);
if ((FLevel=1) and (k=15)) then begin
                              But[4,4].Font.Color:=clGreen;
                              But[4,4].Show;
                              FCongrats:=True;
                              end;
if ((FLevel=2) and (k=24)) then begin
                              But[5,5].Font.Color:=clGreen;
                              But[5,5].Show;
                              FCongrats:=True;
                              end;
if FCongrats then Congratulations;
end;

procedure TScrmbl.Resize;
begin
inherited Resize;
  he:=Round(Height div 5);
  wi:=Round(Width div 5);
    for i:=1 to 5 do
    for j:=1 to 5 do
    But[i,j].SetBounds(wi*Pred(j),he*Pred(i),wi,he);
end;

procedure TScrmbl.WMNCHitTest(var Mes: TWMNCHitTest);
begin
inherited;
  if Mes.Result=htClient 
  then Mes.Result:=htCaption;
end;

procedure TScrmbl.Congratulations;
var
  txt: PChar;
begin
txt:='CONGRATULATIONS!!!!!!!!!!!!!!!!!!!';
for i:=1 to 4 do
for j:=1 to 5 do
begin
 But[i,j].Enabled:=True;
 But[i,j].Caption:=txt[5*Pred(i)+Pred(j)];
end;
for j:=1 to 5 do
 But[5,j].Hide;
end;

end.


